### Function

# PangoCairo ShapeRendererFunc

since: 1.0

#### Declaration

    void
    (* PangoCairoShapeRendererFunc) (
      cairo_t* cr,
      PangoAttrShape* attr,
      gboolean do_path,
      gpointer data
    )

#### Description [src]

Function type for rendering attributes of type `PANGO_ATTR_SHAPE` with Pango’s Cairo renderer.

Available since: 1.0

#### Parameters

`cr`

  Type: `cairo_t`

  A Cairo context with current point set to where the shape should be rendered.

  The data is owned by the caller of the function.

`attr`

  Type: `PangoAttrShape`

  The `PANGO_ATTR_SHAPE` to render.

  The data is owned by the caller of the function.

`do_path`

  Type: `gboolean`

  Whether only the shape path should be appended to current path of `cr` and no filling/stroking done. This will be set to `TRUE` when called from `pango_cairo_layout_path()` and `pango_cairo_layout_line_path()` rendering functions.

`data`

  Type: `gpointer`

  User data passed to `pango_cairo_context_set_shape_renderer()`

  The argument can be `NULL`.
  The data is owned by the caller of the function.